#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: pgsql.tcl,v 1.1 2000/12/01 10:59:33 artur Exp $
#
# Information:
# adabassql<--> Xotcl interface (proxy)

# I have no adabas server on my machine so I could not test it
# It is probably buggy
# If you are interested in getting it to work
# you can learn tcl and xotcl or you better
# contact me mail@xdobry.de
Class AdaSql -superclass Sqlinterface -parameter {
    name
    userkey
    serverdb
    sqlmode
    user
    password
    isolationmode
    {interface adabastcl}
}
AdaSql set interface postgresql
# Instanz Variablen
# sqlhandle - Handle fr 
AdaSql instproc init args {
    package require Adabastcl
    next
}
AdaSql instproc getconnectargs {} {
    global env
    return [list \
		{name text {}} \
		{password password {}} \
		{userkey text {}} \
		{serverdb text {}} \
		{sqlmode text {}} \
		{isolationlevel text {}} \
	    ]
}

AdaSql instproc connect par_list {
    [self] instvar sqlhandle connected dbank user password hostname
    set conninfo {}
    array set par_array [eval concat $par_list]
    #puts "checkpoint"
    set par ""
    if {[info exists par_array(name)] && $par_array(name)!=""} {
	lappend par -user $par_array(user) 
	set user $par_array(user) 
    }
    if {[info exists par_array(password)] && $par_array(password)!=""} {
	lappend par ,$par_array(password) 
	set password $par_array(password) 
    }
    if {[info exists par_array(userkey)] && $par_array(userkey)!=""} {
	if {[info exist user]} {
	    set errorInfo "you cannot define both name and userkey"
	    return 0
	}
	lappend par -host $par_array(userkey) 
	set hostname $par_array(userkey) 
    }
    if {[info exists par_array(serverdb)] && $par_array(socket)!=""} {
	lappend par -serverdb $par_array(serverdb) 
	set serverdb $par_array(serverdb) 
    }
    if {[info exists par_array(sqlmode)] && $par_array(sqlmode)!=""} {
	lappend par -sqlmode $par_array(sqlmode) 
	set dbank $par_array(sqlmode)
    }

    puts "try to connect adalogon $par"
    if {[catch {set sqlhandle [eval adalogon $par]} err]!=0} {
	global errorInfo
	puts "$err $errorInfo"
	return 0
    }
    set connected 1
    return 1
}

AdaSql instproc disconnect {} {
    [self] instvar sqlhandle sqlhandle connected
    if {$connected} {
	adaclose $sqlhandle
    }
    set connected 0
}
AdaSql instproc getdblist {} {
    error "Adabas interface don't support this funktionality. You must know names of your databases"
}
AdaSql instproc setdb dbname {
    error "Adabas interface don't support this funktionality. You must know names of your databases"
}
# it can be expensive to create extra cursor for every query
# it can be improved by caching unused cursors
AdaSql instproc query sqlstatment {
    [self] instvar sqlhandle error_msg
    set qhandle [adaopen $sqlhandle]
    if {[catch {adasql $qhandle -command $sqlstatment}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    set name [Object autoname myAdaQuerry]
    global adamsg
    AdaSql::SqlQuerry [self]::$name -qhandle $qhandle -numTuples $adamsg(rows)
    return [self]::$name
}
# Sendet eine SQL Anweisung an Server (keine SELECT)
AdaSql instproc execute sqlstatement {
    [self] instvar sqlhandle error_msg
    set qhandle [adaopen $sqlhandle]
    if {[catch {adasql $qhandle -command $sqlstatment}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    adaclose $qhandle
    return 0
}
Class AdaSql::SqlQuerry -parameter {
    {qhandle}
    {tindex 0}
    {numTuples}
}
AdaSql::SqlQuerry instproc init {args} {
    next
    [self] instvar numTuples qhandle
    set numTuples [pg_result $qhandle -numTuples]
}
AdaSql::SqlQuerry instproc fetch {} {
    [self] instvar qhandle tindex numTuples
    if {$tindex<$numTuples} {
	set result [adafetch $qhandle -position $tindex]
	incr tindex
    } else {
	set result {}
    }
    #puts "fetch $tindex $result"
    return $result
}
AdaSql::SqlQuerry instproc getinsertid {} {
    [self] instvar qhandle
    return [pg_result $qhandle -oid]
}
AdaSql::SqlQuerry instproc rows {} {
    [self] instvar numTuples
    return $numTuples
}
AdaSql::SqlQuerry instproc seek {point} {
    [self] instvar tindex
    set tindex $point
}
AdaSql::SqlQuerry instproc destroy {} {
    [self] instvar qhandle 
    adaclose $qhandle
    next
}
