#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: pgsql.tcl,v 1.1 2000/12/01 10:59:33 artur Exp $
#
# Information:
# dbitotcl<--> Xotcl interface (proxy)

Class DBISql -superclass Sqlinterface -parameter {
    connstring
    arg1
    arg2
    {interface dbitotcl}
}
DBISql set interface postgresql
# Instanz Variablen
# sqlhandle - Handle fr 
DBISql instproc init args {
    package require dbitotcl
    next
}
DBISql instproc getconnectargs {} {
    global env
    return [list \
		{connstring text {}} \
		{arg1 text {}} \
		{arg2 text {}} \
	    ]
}

DBISql instproc connect par_list {
    [self] instvar sqlhandle connected connstring arg1 arg2 dbank
    set conninfo {}
    array set par_array [eval concat $par_list]
    #puts "checkpoint"
    set par ""
    if {[info exists par_array(connstring)] && $par_array(connstring)!=""} {
	lappend par $par_array(connstring) 
	set connstring $par_array(connstring) 
    } else {
	set errorInfo "you must define DBI connect string"
	return 0
    }
    if {[info exists par_array(arg1)] && $par_array(arg1)!=""} {
	lappend par $par_array(arg1) 
	set arg1 $par_array(arg1) 
    } else {
	set arg1 {}
    }
    if {[info exists par_array(arg2)] && $par_array(arg2)!=""} {
	lappend par $par_array(arg2) 
	set arg2 $par_array(arg2) 
    } else {
	set arg2 {}
    }
    puts "dbi::connect $connstring $arg1 $arg2"
    if {[catch {set sqlhandle [eval dbi::connect $connstring $arg1 $arg2]} err]!=0} {
	global errorInfo
	puts "$err $errorInfo"
	return 0
    }
    set dbank PerlDBI
    set connected 1
    return 1
}

DBISql instproc disconnect {} {
    [self] instvar sqlhandle sqlhandle connected
    if {$connected} {
	$sqlhandle disconnect
    }
    set connected 0
}
DBISql instproc getdblist {} {
    error "generic Perl DBI interface don't support this funktionality. You must know names of your databases"
}
DBISql instproc setdb dbname {
    error "generic Perl DBI interface don't support this funktionality. You must know names of your databases"
}
DBISql instproc query sqlstatment {
    [self] instvar sqlhandle error_msg
    set qhandle [$sqlhandle prepare sqlstatment]
    if {[catch {set qhandle [$sqlhandle prepare $sqlstatment]}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    if {[catch {$qhandle invoke execute}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    set name [Object autoname myDBIQuerry]
    DBISql::SqlQuerry [self]::$name -qhandle $qhandle
    return [self]::$name
}
# Sendet eine SQL Anweisung an Server (keine SELECT)
DBISql instproc execute sqlstatement {
    [self] instvar sqlhandle error_msg
    if {[catch {set ret [$sqlhandle do $sqlstatement]}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    return $ret
}
Class DBISql::SqlQuerry -parameter {
    {qhandle}
}
DBISql::SqlQuerry instproc fetch {} {
    [self] instvar qhandle
    return [$qhandle fetchrow]
}
DBISql::SqlQuerry instproc rows {} {
    [self] instvar qhandle
    return [$qhandle invoke rows]
}
DBISql::SqlQuerry instproc destroy {} {
    [self] instvar qhandle 
    $qhandle finish
    next
}
