#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: mysql.tcl,v 1.1 2000/12/01 10:59:33 artur Exp $
#
# Information:
# mysql<--> Xotcl interface (proxy)

Class MySql -superclass Sqlinterface -parameter {
    user
    password
    hostname
    socket
    {interface mysql}
}
MySql set interface mysql
# Instanz Variablen
# sqlhandle - Handle fr 
MySql instproc init args {
    #package require mysqltcl
    next
}
MySql instproc getconnectargs {} {
    global env
    if {[info exist env(USERNAME)]} {
	set user $env(USERNAME)
    } else {
	set user ""
    }
    return [list \
		{hostname text localhost} \
		{socket text {}} \
		{port integer 3306} \
		[list user text $user] \
		{password password {}} \
		{dbank text {}}
	    ]
	   
}

MySql instproc connect par_list {
    [self] instvar sqlhandle_arr connected dbank user password hostname \
	socket
    array set par_array [eval concat $par_list]
    #puts "checkpoint"
    set par ""
    if {[info exists par_array(user)] && $par_array(user)!=""} {
	lappend par -user $par_array(user) 
	set user $par_array(user) 
    }
    if {[info exists par_array(password)] && $par_array(password)!=""} {
	lappend par -password $par_array(password) 
	set password $par_array(password) 
    }
    if {[info exists par_array(hostname)] && $par_array(hostname)!=""} {
	lappend par -host $par_array(hostname) 
	set hostname $par_array(hostname) 
    }
    if {[info exists par_array(socket)] && $par_array(socket)!=""} {
	lappend par -socket $par_array(socket) 
	set socket $par_array(socket) 
    }
    if {[info exists par_array(dbank)] && $par_array(dbank)!=""} {
	lappend par -db $par_array(dbank) 
	set dbank $par_array(dbank)
    }

    # Kein Tcl-Fehler Abfang
    #puts "$par $par_list"
    if {[catch {set sqlhandle [eval mysqlconnect $par]} err]!=0} {
	global errorInfo
	puts "$err $errorInfo"
	return 0
    }
    set connected 1
    set sqlhandle_arr($sqlhandle) free
#     if {[info exists par_array(dbank)] && $par_array(dbank)!=""} {
# 	if {[catch {mysqluse $sqlhandle $par_array(dbank)} err]!=0} {
# 	    global errorInfo
# 	    puts "$err $errorInfo"
# 	    [self] disconnect
# 	    return 1
# 	}
# 	set dbank $par_array(dbank)
#     }    
    return 1
}

MySql instproc disconnect {} {
    [self] instvar sqlhandle_arr connected handlelist
    foreach handle [array names sqlhandle_arr] {
	mysqlclose $handle
    }
    set connected 0
}
MySql instproc getdblist {} {
    [self] instvar sqlhandle_arr
    set  sqlhandle [lindex [array names sqlhandle_arr] 0]
    return [mysqlinfo $sqlhandle databases]
}
MySql instproc escape string {
    return [mysqlescape $string]
}
MySql instproc setdb dbname {
    [self] instvar sqlhandle_arr dbank
    set sqlhandle [lindex [array names sqlhandle_arr] 0]
    if {[catch {mysqluse $sqlhandle $dbname} err]!=0} {
	global errorInfo
	puts "$err $errorInfo"
	set dbank {}
	return
    }
    set dbank $dbname
}
MySql instproc freehandle handle {
    [self] instvar sqlhandle_arr
    # the hadles are really not freed but only marked as unused
    set sqlhandle_arr($handle) free
}
# Strategie es werden immer neue Hanlde geffnet aber bei nicht bedarf nicht
# freigegeben (Taktik. jedes ffnen dauert zu lange)
MySql instproc gethandle {} {
    [self] instvar sqlhandle_arr
    foreach handle [array names sqlhandle_arr] {
	if {$sqlhandle_arr($handle)=="free"} {
	    return $handle
	}
    }
    return [[self] clonehandle]
}
# Nur fr interne Nutzung
# Gibt ein Hadle zurck auf die gleiche Datenbank und Tabele wie bei dbconnect
# Benutzt um mehrfach Anfragen zu erlauben
MySql instproc clonehandle {} {
    [self] instvar sqlhandle_arr dbank user password hostname socket
    set par ""
    if {[info exists user]} {
	lappend par -user $user
    }
    if {[info exists password]} {
	lappend par -password $password
    }
    if {[info exists hostname]} {
	lappend par -host $hostname
    }
    if {[info exists socket]} {
	lappend par -socket $socket
    }
    if {[info exists dbank]} {
	lappend par -db $dbank
    }
    # Kein Tcl-Fehler Abfang
    #puts "clonehandle $par"
    set chandle [eval mysqlconnect $par]
    # Vorausetzung es wurde eine konkrete dbank bereits gesetzt
    # mysqluse $chandle $dbank
    set sqlhandle_arr($chandle) free
    return $chandle
}
# Sendet eine SQL Anweisung an Server und gibt ein SqlQuerry Objekt
# oder {} beim Fehler
# Zurck, das fr die Tranfersiereung der Antwort (Tablle=Menge) 
# benutzt werden kann
MySql instproc query sqlstatment {
    [self] instvar sqlhandle_arr error_msg
    set qhandle [[self] gethandle]
    set sqlhandle_arr($qhandle) inuse
    if {[catch {set rows [mysqlsel $qhandle $sqlstatment]}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    set name [Object autoname mySqlQuerry]
    MySql::SqlQuerry [self]::$name -qhandle $qhandle -frows $rows
    return [self]::$name
}
# Sendet eine SQL Anweisung an Server (keine SELECT)
# gibt die Zahl von vernderten Tupel oder {} beim Fehler
MySql instproc execute sqlstatement {
    [self] instvar sqlhandle_arr error_msg
    set qhandle [[self] gethandle]
    if {[catch {set ret [mysqlexec $qhandle $sqlstatement]}]} {
	global errorInfo
	set error_msg $errorInfo
	puts $errorInfo
	return {}
    }
    return $ret
}
MySql instproc getinsertid {} {
    [self] instvar sqlhandle_arr
    set qhandle [[self] gethandle]
    return [mysqlinsertid $qhandle]
}
Class MySql::SqlQuerry -parameter {
    {qhandle 0}
    {frows 0}
}

MySql::SqlQuerry instproc fetch {} {
    [self] instvar qhandle
    return [mysqlnext $qhandle]
}
MySql::SqlQuerry instproc rows {} {
    [self] instvar frows
    return $frows
}
MySql::SqlQuerry instproc seek {point} {
    [self] instvar qhandle
    mysqlseek $qhandle $point
}
MySql::SqlQuerry instproc destroy {} {
    [self] instvar qhandle 
    [[self] info parent] freehandle $qhandle
    next
}

